import * as i0 from '@angular/core';
import { EventEmitter, forwardRef, Component, ViewChild, Input, Output, HostListener, Directive, HostBinding, ContentChild, Attribute, NgModule } from '@angular/core';
import { trigger, state, style, transition, animate, group, query, animateChild } from '@angular/animations';
import * as i3 from '@angular/forms';
import { NG_VALUE_ACCESSOR, NG_VALIDATORS, ReactiveFormsModule, FormsModule } from '@angular/forms';
import * as i1 from '@angular/common/http';
import { HttpHeaders, HttpClientModule } from '@angular/common/http';
import * as i2 from '@angular/common';
import { CommonModule } from '@angular/common';
import { combineLatest, of } from 'rxjs';
import { map } from 'rxjs/operators';

class NeSoftCheckboxComponent {
    // @HostBinding('style.fontFamily') get baseFont(): string {
    //   return this.themingService.palette.ThemingFont;
    // };
    constructor() {
        this.mvalue = false;
        this.required = false;
        this.centralize = false;
        this.disabled = false;
        this.controlLoaded = false;
        this.ngModelChange = new EventEmitter();
    }
    set ngModel(value) {
        this.mvalue = value;
        if (this.controlLoaded) {
            this.ngModelChange.emit(this.mvalue);
        }
    }
    get ngModel() {
        return this.mvalue;
    }
    ngAfterViewInit() {
        this.controlLoaded = true;
    }
    ngOnInit() {
        this.drawCheckbox();
    }
    drawCheckbox() {
        const ctx = this.lineLeft.nativeElement.getContext('2d');
        ctx.beginPath();
        ctx.strokeStyle = '#585858';
        ctx.lineWidth = 1;
        ctx.moveTo(3, 3);
        ctx.lineTo(15, 15);
        ctx.stroke();
        const ctx2 = this.lineRight.nativeElement.getContext('2d');
        ctx2.beginPath();
        ctx2.strokeStyle = '#585858';
        ctx2.lineWidth = 1;
        ctx2.moveTo(3, 15);
        ctx2.lineTo(15, 3);
        ctx2.stroke();
    }
    setNgModel() {
        if (!this.disabled) {
            this.ngModel = !this.ngModel;
            if (this.onChange) {
                this.onChange(this.ngModel ? true : false);
            }
            if (this.onTouch) {
                this.onTouch();
            }
        }
    }
    registerOnChange(fn) {
        this.onChange = fn;
    }
    registerOnTouched(fn) {
        this.onTouch = fn;
    }
    writeValue(obj) {
        this.ngModel = obj;
    }
    validate(control) {
        return (this.required && this.ngModel === false) ? { required: true } : null;
    }
}
NeSoftCheckboxComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NeSoftCheckboxComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NeSoftCheckboxComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.0.0", type: NeSoftCheckboxComponent, selector: "nesoft-checkbox", inputs: { required: "required", centralize: "centralize", disabled: "disabled", ngModel: "ngModel" }, outputs: { ngModelChange: "ngModelChange" }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: forwardRef(() => NeSoftCheckboxComponent),
            multi: true
        },
        {
            provide: NG_VALIDATORS,
            useExisting: forwardRef(() => NeSoftCheckboxComponent),
            multi: true,
        }
    ], viewQueries: [{ propertyName: "lineLeft", first: true, predicate: ["lineLeft"], descendants: true, static: true }, { propertyName: "lineRight", first: true, predicate: ["lineRight"], descendants: true, static: true }], ngImport: i0, template: "<div class=\"nesoft-checkbox-container {{disabled ? 'disabled' : ''}}\" #checkcontrol (click)=\"setNgModel()\">\n  <canvas class=\"nesoft-checkbox-canvas\" id=\"checkboxleftline\" #lineLeft width=\"20\" height=\"20\" [@leftLine]=\"ngModel? true : false\"></canvas>\n  <canvas class=\"nesoft-checkbox-canvas\" id=\"checkboxrightline\" #lineRight width=\"25\" height=\"20\" [@rightLine]=\"ngModel? true : false\"></canvas>\n  <div class=\"nesoft-checkbox-background {{disabled ? 'disabled' : ''}}\" [@controlBack]=\"ngModel? true : false\"></div>\n</div>\n\n", animations: [
        trigger('leftLine', [
            state('0', style({
                left: '-100%',
                top: '-100%'
            })),
            state('1', style({
                left: '0%',
                top: '0%'
            })),
            transition('1 => 0', animate('200ms')),
            transition('0 => 1', animate('200ms'))
        ]),
        trigger('rightLine', [
            state('0', style({
                left: '-100%',
                top: '100%'
            })),
            state('1', style({
                left: '0%',
                top: '0%'
            })),
            transition('1 => 0', animate('200ms')),
            transition('0 => 1', animate('200ms'))
        ]),
        trigger('controlBack', [
            state('0', style({
                opacity: 0
            })),
            state('1', style({
                opacity: 1
            })),
            transition('1 => 0', animate('200ms 100ms')),
            transition('0 => 1', animate('200ms'))
        ])
    ] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NeSoftCheckboxComponent, decorators: [{
            type: Component,
            args: [{ selector: 'nesoft-checkbox', animations: [
                        trigger('leftLine', [
                            state('0', style({
                                left: '-100%',
                                top: '-100%'
                            })),
                            state('1', style({
                                left: '0%',
                                top: '0%'
                            })),
                            transition('1 => 0', animate('200ms')),
                            transition('0 => 1', animate('200ms'))
                        ]),
                        trigger('rightLine', [
                            state('0', style({
                                left: '-100%',
                                top: '100%'
                            })),
                            state('1', style({
                                left: '0%',
                                top: '0%'
                            })),
                            transition('1 => 0', animate('200ms')),
                            transition('0 => 1', animate('200ms'))
                        ]),
                        trigger('controlBack', [
                            state('0', style({
                                opacity: 0
                            })),
                            state('1', style({
                                opacity: 1
                            })),
                            transition('1 => 0', animate('200ms 100ms')),
                            transition('0 => 1', animate('200ms'))
                        ])
                    ], providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => NeSoftCheckboxComponent),
                            multi: true
                        },
                        {
                            provide: NG_VALIDATORS,
                            useExisting: forwardRef(() => NeSoftCheckboxComponent),
                            multi: true,
                        }
                    ], template: "<div class=\"nesoft-checkbox-container {{disabled ? 'disabled' : ''}}\" #checkcontrol (click)=\"setNgModel()\">\n  <canvas class=\"nesoft-checkbox-canvas\" id=\"checkboxleftline\" #lineLeft width=\"20\" height=\"20\" [@leftLine]=\"ngModel? true : false\"></canvas>\n  <canvas class=\"nesoft-checkbox-canvas\" id=\"checkboxrightline\" #lineRight width=\"25\" height=\"20\" [@rightLine]=\"ngModel? true : false\"></canvas>\n  <div class=\"nesoft-checkbox-background {{disabled ? 'disabled' : ''}}\" [@controlBack]=\"ngModel? true : false\"></div>\n</div>\n\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { lineLeft: [{
                type: ViewChild,
                args: ['lineLeft', { static: true }]
            }], lineRight: [{
                type: ViewChild,
                args: ['lineRight', { static: true }]
            }], required: [{
                type: Input
            }], centralize: [{
                type: Input
            }], disabled: [{
                type: Input
            }], ngModel: [{
                type: Input
            }], ngModelChange: [{
                type: Output
            }] } });

class NeSoftRadioItemComponent {
    constructor() {
        this.Text = '';
        this.Value = '';
        this.HasError = false;
        this.HasSuccess = false;
        this.Tag = '';
        this.TagChange = new EventEmitter();
        this.updateValidation = new EventEmitter();
    }
    onClick() {
        this.changeState();
    }
    get selected() {
        return this.Value === this.Tag;
    }
    changeState() {
        if (this.Tag !== this.Value) {
            this.Tag = this.Value;
            this.TagChange.emit(this.Value);
            this.updateValidation.emit(this.Value);
        }
    }
}
NeSoftRadioItemComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NeSoftRadioItemComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NeSoftRadioItemComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.0.0", type: NeSoftRadioItemComponent, selector: "nesoft-radio-item", inputs: { Text: "Text", Value: "Value", HasError: "HasError", HasSuccess: "HasSuccess", Tag: "Tag" }, outputs: { TagChange: "TagChange", updateValidation: "updateValidation" }, host: { listeners: { "click": "onClick()" } }, ngImport: i0, template: "<div class=\"nesoft-radio-item-container {{HasError ? 'error' : ''}} {{HasSuccess ? 'success' : ''}}\">\n  <div class=\"nesoft-radio-item-selected\" [@showHideContainer]=\"selected\"></div>\n</div>\n<div class=\"nesoft-radio-item-text\">{{Text}}</div>\n", animations: [
        trigger('showHideContainer', [
            state('0', style({
                opacity: '0',
            })),
            state('1', style({
                opacity: '1'
            })),
            transition('1 => 0', animate('200ms ease-in')),
            transition('0 => 1', animate('200ms ease-out'))
        ])
    ] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NeSoftRadioItemComponent, decorators: [{
            type: Component,
            args: [{ selector: 'nesoft-radio-item', animations: [
                        trigger('showHideContainer', [
                            state('0', style({
                                opacity: '0',
                            })),
                            state('1', style({
                                opacity: '1'
                            })),
                            transition('1 => 0', animate('200ms ease-in')),
                            transition('0 => 1', animate('200ms ease-out'))
                        ])
                    ], template: "<div class=\"nesoft-radio-item-container {{HasError ? 'error' : ''}} {{HasSuccess ? 'success' : ''}}\">\n  <div class=\"nesoft-radio-item-selected\" [@showHideContainer]=\"selected\"></div>\n</div>\n<div class=\"nesoft-radio-item-text\">{{Text}}</div>\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { Text: [{
                type: Input
            }], Value: [{
                type: Input
            }], HasError: [{
                type: Input
            }], HasSuccess: [{
                type: Input
            }], Tag: [{
                type: Input
            }], TagChange: [{
                type: Output
            }], updateValidation: [{
                type: Output
            }], onClick: [{
                type: HostListener,
                args: ['click']
            }] } });

class RadioModel {
    constructor(Id = '', Name = '', Value = '') {
        this.Id = Id;
        this.Name = Name;
        this.Value = Value;
    }
}
class NeSoftRadioComponent {
    // @HostBinding('style.fontFamily') get baseFont(): string {
    //   return this.themingService.palette.ThemingFont;
    // };
    constructor(elementRef, httpClient) {
        this.elementRef = elementRef;
        this.httpClient = httpClient;
        this.targetUrl = '';
        this.required = false;
        this.ngModel = '';
        this.ngModelChange = new EventEmitter();
    }
    get isSuccess() {
        return this.elementRef.nativeElement.classList.contains("ng-valid")
            && this.elementRef.nativeElement.classList.contains("ng-dirty")
            && this.elementRef.nativeElement.classList.contains("ng-touched");
    }
    get isError() {
        return this.elementRef.nativeElement.classList.contains("ng-invalid")
            && this.elementRef.nativeElement.classList.contains("ng-dirty")
            && this.elementRef.nativeElement.classList.contains("ng-touched");
    }
    async ngOnInit() {
        //this.radioItems = await this.getRadioItems();
        this.radioItems = [{ Id: '1', Name: 'Frau', Value: 'Frau' }, { Id: '2', Name: 'Herr', Value: 'Herr' }];
    }
    async getRadioItems() {
        const options = {
            headers: new HttpHeaders({
                'Content-Type': `application/json`,
                Accept: 'application/json;'
            })
        };
        return this.httpClient.get(this.targetUrl, options).toPromise();
    }
    updateValidation() {
        this.onTouch();
        this.onChange(this.ngModel);
        this.ngModelChange.emit(this.ngModel);
    }
    registerOnChange(fn) {
        this.onChange = fn;
    }
    registerOnTouched(fn) {
        this.onTouch = fn;
    }
    writeValue(obj) {
        this.ngModel = obj;
    }
    validate(control) {
        return (this.required && this.ngModel === '') ? { required: true } : null;
    }
}
NeSoftRadioComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NeSoftRadioComponent, deps: [{ token: i0.ElementRef }, { token: i1.HttpClient }], target: i0.ɵɵFactoryTarget.Component });
NeSoftRadioComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.0.0", type: NeSoftRadioComponent, selector: "nesoft-radio", inputs: { targetUrl: "targetUrl", required: "required", ngModel: "ngModel" }, outputs: { ngModelChange: "ngModelChange" }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: forwardRef(() => NeSoftRadioComponent),
            multi: true
        },
        {
            provide: NG_VALIDATORS,
            useExisting: forwardRef(() => NeSoftRadioComponent),
            multi: true,
        }
    ], ngImport: i0, template: "<nesoft-radio-item *ngFor=\"let itm of radioItems\" [Text]=\"itm.Value\" [Value]=\"itm.Id\" [HasError]=\"isError\"\n                   [HasSuccess]=\"isSuccess\" [(Tag)]=\"ngModel\"\n                   (updateValidation)=\"updateValidation()\"></nesoft-radio-item>\n", dependencies: [{ kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "component", type: NeSoftRadioItemComponent, selector: "nesoft-radio-item", inputs: ["Text", "Value", "HasError", "HasSuccess", "Tag"], outputs: ["TagChange", "updateValidation"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NeSoftRadioComponent, decorators: [{
            type: Component,
            args: [{ selector: 'nesoft-radio', providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => NeSoftRadioComponent),
                            multi: true
                        },
                        {
                            provide: NG_VALIDATORS,
                            useExisting: forwardRef(() => NeSoftRadioComponent),
                            multi: true,
                        }
                    ], template: "<nesoft-radio-item *ngFor=\"let itm of radioItems\" [Text]=\"itm.Value\" [Value]=\"itm.Id\" [HasError]=\"isError\"\n                   [HasSuccess]=\"isSuccess\" [(Tag)]=\"ngModel\"\n                   (updateValidation)=\"updateValidation()\"></nesoft-radio-item>\n" }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i1.HttpClient }]; }, propDecorators: { targetUrl: [{
                type: Input
            }], required: [{
                type: Input
            }], ngModel: [{
                type: Input
            }], ngModelChange: [{
                type: Output
            }] } });

class NeSoftInputDirective {
    constructor(el) {
        this.el = el;
        this.modelChanged = new EventEmitter();
        this.ngModelChange = new EventEmitter();
    }
    set ngModel(value) {
        this.val = value;
        this.modelChanged.emit(this.val);
    }
    get ngModel() {
        return this.val;
    }
    get isError() {
        return this.el.nativeElement.classList.contains("ng-invalid")
            && this.el.nativeElement.classList.contains("ng-dirty")
            && this.el.nativeElement.classList.contains("ng-touched");
    }
    get isSuccess() {
        return this.el.nativeElement.classList.contains("ng-valid")
            && this.el.nativeElement.classList.contains("ng-dirty")
            && this.el.nativeElement.classList.contains("ng-touched");
    }
    clearInput() {
        this.ngModel = null;
        this.ngModelChange.emit(this.ngModel);
    }
    get nesoftInput() {
        if (this.el.nativeElement.tagName.toLowerCase() === "input") {
            return true;
        }
        return false;
    }
    get nesoftInputArea() {
        if (this.el.nativeElement.tagName.toLowerCase() === "textarea") {
            return true;
        }
        return false;
    }
    get baseSize() {
        return '11pt';
    }
    ;
    getIfRequired() {
        return this.el.nativeElement.required;
    }
    getType() {
        return this.el.nativeElement.type;
    }
    setType(tp) {
        this.el.nativeElement.type = tp;
    }
}
NeSoftInputDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NeSoftInputDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
NeSoftInputDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.0.0", type: NeSoftInputDirective, selector: "[nesoftInput]", inputs: { ngModel: "ngModel" }, outputs: { ngModelChange: "ngModelChange" }, host: { properties: { "class.nesoftInput": "this.nesoftInput", "class.nesoftInputArea": "this.nesoftInputArea", "style.fontSize": "this.baseSize" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NeSoftInputDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[nesoftInput]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { ngModel: [{
                type: Input
            }], ngModelChange: [{
                type: Output
            }], nesoftInput: [{
                type: HostBinding,
                args: ['class.nesoftInput']
            }], nesoftInputArea: [{
                type: HostBinding,
                args: ['class.nesoftInputArea']
            }], baseSize: [{
                type: HostBinding,
                args: ['style.fontSize']
            }] } });

class ReferenceModel {
    constructor(Id = '', Name = '', Value = '') {
        this.Id = Id;
        this.Name = Name;
        this.Value = Value;
    }
}
class NeSoftInputReferenceComponent {
    constructor(httpClient, cdr) {
        this.httpClient = httpClient;
        this.cdr = cdr;
        this.required = false;
        this.disabled = false;
        this.targetUrl = '';
        this.loadRefObject = false;
        this.refObject = new EventEmitter();
        this.searchLst = [];
        this.mselObjId = '';
        this.msearchValue = '';
        this.objDescription = '';
        this.wasInside = false;
        this.controlLoaded = false;
        this.ngModelChange = new EventEmitter();
    }
    set searchValue(value) {
        this.msearchValue = value;
        if (this.msearchValue) {
            this.loadSearchList();
        }
        else {
            this.searchLst = [];
        }
    }
    get searchValue() {
        return this.msearchValue;
    }
    set ngModel(value) {
        this.mselObjId = value;
        if (this.controlLoaded) {
            this.initialize().then(() => {
                this.ngModelChange.emit(this.mselObjId);
            });
        }
    }
    get ngModel() {
        return this.mselObjId;
    }
    clickInside() {
        this.wasInside = true;
    }
    clickout() {
        if (!this.wasInside) {
            this.searchLst = [];
        }
        this.wasInside = false;
    }
    async ngOnInit() {
        // this.compInfo = await this.compTypeService.getCompObject(this.tblname);
        // this.searchval?.control?.updateValueAndValidity();
    }
    openDetailComp() {
        // const icon: string = this.compInfo.classInfo?.Icon ? this.compInfo.classInfo?.Icon : '';
        // const cption: string = this.compInfo.classInfo?.Caption ? this.compInfo.classInfo?.Caption : '';
        // this.dialogerService.addNewDialog(
        //   'detail' + this.tblname,
        //   cption + ' anschauen - ' + this.objDescription,
        //   icon,
        //   {
        //     objId: this.ngModel
        //   },
        //   this.compInfo?.detailComp
        // ).subscribe(async (value: any) => {
        //   await this.initialize();
        // });
    }
    openEditComp() {
        // const icon: string = this.compInfo.classInfo?.Icon ? this.compInfo.classInfo?.Icon : '';
        // const cption: string = this.compInfo.classInfo?.Caption ? this.compInfo.classInfo?.Caption : '';
        // this.dialogerService.addNewDialog(
        //   'edit' + this.tblname,
        //   cption + ' bearbeiten - ' + this.objDescription,
        //   icon,
        //   {
        //     objId: this.ngModel
        //   },
        //   this.compInfo?.updateComp
        // ).subscribe(async () => {
        //   await this.initialize();
        // });
    }
    openCreateComp() {
        // const icon: string = this.compInfo.classInfo?.Icon ? this.compInfo.classInfo?.Icon : '';
        // const cption: string = this.compInfo.classInfo?.Caption ? this.compInfo.classInfo?.Caption : '';
        //
        // this.dialogerService.addNewDialog(
        //   'create' + this.tblname,
        //   cption + ' erstellen',
        //   icon,
        //   {
        //     objId: null
        //   },
        //   this.compInfo?.createComp
        // ).subscribe(async (value: any) => {
        //   this.ngModel = value;
        // });
    }
    clearValue() {
        this.ngModel = null;
        this.objDescription = '';
        this.onChange(this.ngModel);
        this.refObject.emit({});
        this.onTouch();
    }
    async getSearchResults() {
        const options = {
            headers: new HttpHeaders({
                'Content-Type': `application/json`,
                Accept: 'application/json;version=1.0'
            })
        };
        const url = this.targetUrl + `?strval=${this.searchValue}`;
        return this.httpClient.get(url, options).toPromise();
    }
    loadSearchList() {
        this.getSearchResults().then((lst) => {
            this.searchLst = lst;
        });
    }
    async initialize() {
        if (this.mselObjId) {
            this.objDescription = await this.getObjectDesc();
            if (this.loadRefObject) {
                const refObj = await this.getRefObject();
                this.refObject.emit(refObj);
            }
        }
        else {
            this.objDescription = '';
        }
    }
    async getRefObject() {
        const options = {
            headers: new HttpHeaders({
                'Content-Type': `application/json`,
                Accept: 'application/json;version=1.0'
            })
        };
        const url = this.targetUrl + `/${this.mselObjId}`;
        return this.httpClient.get(url, options).toPromise();
    }
    async getObjectDesc() {
        const options = {
            headers: new HttpHeaders({
                'Content-Type': `application/json`,
                Accept: 'application/json;version=1.0'
            })
        };
        const url = this.targetUrl + `/${this.ngModel}/ref`;
        return this.httpClient.get(url, options).toPromise();
    }
    registerOnChange(fn) {
        this.onChange = fn;
    }
    registerOnTouched(fn) {
        this.onTouch = fn;
    }
    writeValue(obj) {
        this.ngModel = obj;
    }
    validate(control) {
        return (this.required === true && this.ngModel === '') ? { required: true } : null;
    }
    ngAfterViewInit() {
        this.controlLoaded = true;
    }
}
NeSoftInputReferenceComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NeSoftInputReferenceComponent, deps: [{ token: i1.HttpClient }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Component });
NeSoftInputReferenceComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.0.0", type: NeSoftInputReferenceComponent, selector: "nesoft-reference", inputs: { required: "required", disabled: "disabled", targetUrl: "targetUrl", loadRefObject: "loadRefObject", ngModel: "ngModel" }, outputs: { refObject: "refObject", ngModelChange: "ngModelChange" }, host: { listeners: { "click": "clickInside()", "document:click": "clickout()" } }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: forwardRef(() => NeSoftInputReferenceComponent),
            multi: true
        },
        {
            provide: NG_VALIDATORS,
            useExisting: forwardRef(() => NeSoftInputReferenceComponent),
            multi: true,
        }
    ], viewQueries: [{ propertyName: "searchval", first: true, predicate: ["searchval"], descendants: true }], ngImport: i0, template: "<div class=\"nesoft-reference-control\" *ngIf=\"ngModel\">\n  <input class=\"nesoft-reference-control-text\" type=\"text\" [value]=\"objDescription\" (dblclick)=\"openDetailComp();\"\n         nesoftInput [readOnly]=\"true\"/>\n</div>\n<div class=\"nesoft-reference-control\" *ngIf=\"!ngModel\">\n  <input class=\"nesoft-reference-control-text\" type=\"text\" [(ngModel)]=\"searchValue\" name=\"searchval\"\n         #searchval=\"ngModel\" (ngModelChange)=\"onChange(); onTouch();\"\n         (click)=\"onChange(); onTouch();loadSearchList();\" required autocomplete=\"false\"\n         [disabled]=\"disabled\" nesoftInput/>\n</div>\n<div class=\"nesoft-reference-actions\">\n  <button [disabled]=\"!ngModel\" (click)=\"openEditComp();\" class=\"nesoft-reference-button-edit\">\n    <i class=\"fal fa-pen\"></i>\n  </button>\n  <button (click)=\"openCreateComp();\" class=\"nesoft-reference-button-create\">\n    <i class=\"fal fa-plus\"></i>\n  </button>\n  <button [disabled]=\"!ngModel || disabled\" (click)=\"clearValue()\" class=\"nesoft-reference-button-remove\">\n    <i class=\"fal fa-times\"></i>\n  </button>\n</div>\n<div class=\"nesoft-reference-suggestions\" *ngIf=\"searchLst && searchLst.length > 0\">\n  <div *ngFor=\"let itm of searchLst; let indx = index;\" class=\"nesoft-reference-suggestions-item\"\n       (click)=\"ngModel = itm.Key; searchLst = []; searchValue = ''\">\n    {{itm.Value}}\n  </div>\n</div>\n", dependencies: [{ kind: "directive", type: i2.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { kind: "directive", type: i3.DefaultValueAccessor, selector: "input:not([type=checkbox])[formControlName],textarea[formControlName],input:not([type=checkbox])[formControl],textarea[formControl],input:not([type=checkbox])[ngModel],textarea[ngModel],[ngDefaultControl]" }, { kind: "directive", type: i3.NgControlStatus, selector: "[formControlName],[ngModel],[formControl]" }, { kind: "directive", type: i3.RequiredValidator, selector: ":not([type=checkbox])[required][formControlName],:not([type=checkbox])[required][formControl],:not([type=checkbox])[required][ngModel]", inputs: ["required"] }, { kind: "directive", type: i3.NgModel, selector: "[ngModel]:not([formControlName]):not([formControl])", inputs: ["name", "disabled", "ngModel", "ngModelOptions"], outputs: ["ngModelChange"], exportAs: ["ngModel"] }, { kind: "directive", type: NeSoftInputDirective, selector: "[nesoftInput]", inputs: ["ngModel"], outputs: ["ngModelChange"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NeSoftInputReferenceComponent, decorators: [{
            type: Component,
            args: [{ selector: 'nesoft-reference', providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => NeSoftInputReferenceComponent),
                            multi: true
                        },
                        {
                            provide: NG_VALIDATORS,
                            useExisting: forwardRef(() => NeSoftInputReferenceComponent),
                            multi: true,
                        }
                    ], template: "<div class=\"nesoft-reference-control\" *ngIf=\"ngModel\">\n  <input class=\"nesoft-reference-control-text\" type=\"text\" [value]=\"objDescription\" (dblclick)=\"openDetailComp();\"\n         nesoftInput [readOnly]=\"true\"/>\n</div>\n<div class=\"nesoft-reference-control\" *ngIf=\"!ngModel\">\n  <input class=\"nesoft-reference-control-text\" type=\"text\" [(ngModel)]=\"searchValue\" name=\"searchval\"\n         #searchval=\"ngModel\" (ngModelChange)=\"onChange(); onTouch();\"\n         (click)=\"onChange(); onTouch();loadSearchList();\" required autocomplete=\"false\"\n         [disabled]=\"disabled\" nesoftInput/>\n</div>\n<div class=\"nesoft-reference-actions\">\n  <button [disabled]=\"!ngModel\" (click)=\"openEditComp();\" class=\"nesoft-reference-button-edit\">\n    <i class=\"fal fa-pen\"></i>\n  </button>\n  <button (click)=\"openCreateComp();\" class=\"nesoft-reference-button-create\">\n    <i class=\"fal fa-plus\"></i>\n  </button>\n  <button [disabled]=\"!ngModel || disabled\" (click)=\"clearValue()\" class=\"nesoft-reference-button-remove\">\n    <i class=\"fal fa-times\"></i>\n  </button>\n</div>\n<div class=\"nesoft-reference-suggestions\" *ngIf=\"searchLst && searchLst.length > 0\">\n  <div *ngFor=\"let itm of searchLst; let indx = index;\" class=\"nesoft-reference-suggestions-item\"\n       (click)=\"ngModel = itm.Key; searchLst = []; searchValue = ''\">\n    {{itm.Value}}\n  </div>\n</div>\n" }]
        }], ctorParameters: function () { return [{ type: i1.HttpClient }, { type: i0.ChangeDetectorRef }]; }, propDecorators: { required: [{
                type: Input
            }], disabled: [{
                type: Input
            }], targetUrl: [{
                type: Input
            }], loadRefObject: [{
                type: Input
            }], refObject: [{
                type: Output
            }], ngModel: [{
                type: Input
            }], ngModelChange: [{
                type: Output
            }], searchval: [{
                type: ViewChild,
                args: ["searchval"]
            }], clickInside: [{
                type: HostListener,
                args: ['click']
            }], clickout: [{
                type: HostListener,
                args: ['document:click']
            }] } });

class NeSoftPrefixDirective {
    constructor(el) {
        this.el = el;
        this.modelChanged = new EventEmitter();
        this.ngModelChange = new EventEmitter();
    }
    set ngModel(value) {
        this.val = value;
        this.modelChanged.emit(this.val);
    }
    get ngModel() {
        return this.val;
    }
    nesoftInputPrefix() {
        return true;
    }
    clearInput() {
        this.ngModel = null;
        this.ngModelChange.emit(this.ngModel);
    }
}
NeSoftPrefixDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NeSoftPrefixDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
NeSoftPrefixDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.0.0", type: NeSoftPrefixDirective, selector: "[nesoftPrefix]", inputs: { ngModel: "ngModel" }, outputs: { ngModelChange: "ngModelChange" }, host: { properties: { "class.nesoftInputPrefix": "this.nesoftInputPrefix" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NeSoftPrefixDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[nesoftPrefix]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { ngModel: [{
                type: Input
            }], ngModelChange: [{
                type: Output
            }], nesoftInputPrefix: [{
                type: HostBinding,
                args: ['class.nesoftInputPrefix']
            }] } });

class NeSoftSuffixDirective {
    constructor(el) {
        this.el = el;
        this.modelChanged = new EventEmitter();
        this.ngModelChange = new EventEmitter();
    }
    set ngModel(value) {
        this.val = value;
        this.modelChanged.emit(this.val);
    }
    get ngModel() {
        return this.val;
    }
    nesoftInputSuffix() {
        return true;
    }
    clearInput() {
        this.ngModel = null;
        this.ngModelChange.emit(this.ngModel);
    }
}
NeSoftSuffixDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NeSoftSuffixDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
NeSoftSuffixDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.0.0", type: NeSoftSuffixDirective, selector: "[nesoftSuffix]", inputs: { ngModel: "ngModel" }, outputs: { ngModelChange: "ngModelChange" }, host: { properties: { "class.nesoftInputSuffix": "this.nesoftInputSuffix" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NeSoftSuffixDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[nesoftSuffix]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { ngModel: [{
                type: Input
            }], ngModelChange: [{
                type: Output
            }], nesoftInputSuffix: [{
                type: HostBinding,
                args: ['class.nesoftInputSuffix']
            }] } });

class NeSoftInputComponent {
    //
    // get colorFromPalette(): string {
    //   return this.themingService.palette.ThemingColor;
    // }
    //
    // get fontFromPalette(): string {
    //   return this.themingService.palette.ThemingFont;
    // }
    constructor() {
        this.labelText = '';
        this.showPwd = false;
    }
    get required() {
        if (this.radioInput) {
            return this.radioInput.required;
        }
        else if (this.checkboxInput) {
            return this.checkboxInput.required;
        }
        else if (this.referenceInput) {
            return this.referenceInput.required;
        }
        else {
            return (this.inputControl === null ? false : this.inputControl?.getIfRequired());
        }
    }
    ;
    get noPrefix() {
        return this.prefixControl !== undefined;
    }
    get noSuffix() {
        return this.suffixControl !== undefined;
    }
    get isPwd() {
        if (this.showPwd === true) {
            return this.showPwd;
        }
        return this.inputControl?.getType() === 'password';
    }
    ;
    get noLabelPadding() {
        return (this.radioInput !== undefined || this.checkboxInput !== undefined);
    }
    //
    // @HostBinding('style.fontFamily') get baseFont(): string {
    //   return this.themingService.palette.ThemingFont;
    // };
    //
    changeInputType() {
        this.showPwd = !this.showPwd;
        this.inputControl?.setType(this.showPwd ? 'text' : 'password');
    }
}
NeSoftInputComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NeSoftInputComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NeSoftInputComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.0.0", type: NeSoftInputComponent, selector: "nesoft-input", inputs: { labelText: "labelText" }, queries: [{ propertyName: "inputControl", first: true, predicate: NeSoftInputDirective, descendants: true }, { propertyName: "prefixControl", first: true, predicate: NeSoftPrefixDirective, descendants: true }, { propertyName: "suffixControl", first: true, predicate: NeSoftSuffixDirective, descendants: true }, { propertyName: "referenceInput", first: true, predicate: NeSoftInputReferenceComponent, descendants: true }, { propertyName: "radioInput", first: true, predicate: NeSoftRadioComponent, descendants: true }, { propertyName: "checkboxInput", first: true, predicate: NeSoftCheckboxComponent, descendants: true }], ngImport: i0, template: "<div class=\"nesoft-input-container\">\n  <div class=\"nesoft-input-label-container {{required ? 'req': ''}}\">\n    {{labelText}}\n    <span class=\"nesoft-input-label-required\" *ngIf=\"required\">*</span>\n  </div>\n  <div class=\"nesoft-input-control-container\">\n    <div class=\"nesoft-input-control-prefix\" [class.noPrefix]=\"!noPrefix\">\n      <ng-content select=\"[nesoftPrefix]\"></ng-content>\n    </div>\n    <div class=\"nesoft-input-control-controls\" [class.noPrefix]=\"!noPrefix\" [class.noSuffix]=\"!noSuffix\"\n         [class.NoPrefixSuffix]=\"!noPrefix && !noSuffix\">\n      <ng-content select=\"[nesoftInput]\"></ng-content>\n      <ng-content select=\"nesoft-radio\"></ng-content>\n      <ng-content select=\"nesoft-checkbox\"></ng-content>\n      <ng-content select=\"nesoft-reference\"></ng-content>\n      <ng-content select=\"nesoft-input-error\"></ng-content>\n      <button class=\"nesoft-input-control-controls-pwd\" *ngIf=\"isPwd\" [class.pwdShow]=\"showPwd\" [class.pwdHide]=\"!showPwd\" (click)=\"changeInputType()\"></button>\n    </div>\n    <div class=\"nesoft-input-control-suffix\" [class.noSuffix]=\"!noSuffix\">\n      <ng-content select=\"[nesoftSuffix]\"></ng-content>\n    </div>\n  </div>\n</div>\n", dependencies: [{ kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NeSoftInputComponent, decorators: [{
            type: Component,
            args: [{ selector: 'nesoft-input', template: "<div class=\"nesoft-input-container\">\n  <div class=\"nesoft-input-label-container {{required ? 'req': ''}}\">\n    {{labelText}}\n    <span class=\"nesoft-input-label-required\" *ngIf=\"required\">*</span>\n  </div>\n  <div class=\"nesoft-input-control-container\">\n    <div class=\"nesoft-input-control-prefix\" [class.noPrefix]=\"!noPrefix\">\n      <ng-content select=\"[nesoftPrefix]\"></ng-content>\n    </div>\n    <div class=\"nesoft-input-control-controls\" [class.noPrefix]=\"!noPrefix\" [class.noSuffix]=\"!noSuffix\"\n         [class.NoPrefixSuffix]=\"!noPrefix && !noSuffix\">\n      <ng-content select=\"[nesoftInput]\"></ng-content>\n      <ng-content select=\"nesoft-radio\"></ng-content>\n      <ng-content select=\"nesoft-checkbox\"></ng-content>\n      <ng-content select=\"nesoft-reference\"></ng-content>\n      <ng-content select=\"nesoft-input-error\"></ng-content>\n      <button class=\"nesoft-input-control-controls-pwd\" *ngIf=\"isPwd\" [class.pwdShow]=\"showPwd\" [class.pwdHide]=\"!showPwd\" (click)=\"changeInputType()\"></button>\n    </div>\n    <div class=\"nesoft-input-control-suffix\" [class.noSuffix]=\"!noSuffix\">\n      <ng-content select=\"[nesoftSuffix]\"></ng-content>\n    </div>\n  </div>\n</div>\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { labelText: [{
                type: Input
            }], inputControl: [{
                type: ContentChild,
                args: [NeSoftInputDirective]
            }], prefixControl: [{
                type: ContentChild,
                args: [NeSoftPrefixDirective]
            }], suffixControl: [{
                type: ContentChild,
                args: [NeSoftSuffixDirective]
            }], referenceInput: [{
                type: ContentChild,
                args: [NeSoftInputReferenceComponent]
            }], radioInput: [{
                type: ContentChild,
                args: [NeSoftRadioComponent]
            }], checkboxInput: [{
                type: ContentChild,
                args: [NeSoftCheckboxComponent]
            }] } });

class NeSoftErrorComponent {
    constructor() {
    }
}
NeSoftErrorComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NeSoftErrorComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NeSoftErrorComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.0.0", type: NeSoftErrorComponent, selector: "nesoft-input-error", host: { properties: { "@showHideBg": "this.showHideBg" } }, ngImport: i0, template: "<p class=\"nesoft-input-error-container\">\n  <ng-content></ng-content>\n</p>\n", styles: [""], animations: [
        trigger('showHideBg', [
            transition(':enter', [
                group([
                    query(':self', [
                        style({
                            height: '0px'
                        }),
                        animate('300ms ease-in', style({
                            height: '*'
                        }))
                    ]),
                    query('.nesoft-input-error-container', [
                        style({
                            transform: 'translateY(100%)'
                        }),
                        animate('300ms ease-in', style({
                            transform: 'translateY(0%)'
                        }))
                    ]),
                    query('@*', animateChild(), { optional: true })
                ])
            ]),
            transition(':leave', [
                group([
                    query(':self', [
                        style({
                            height: '*'
                        }),
                        animate('300ms ease-out', style({
                            height: '0px'
                        }))
                    ]),
                    query('.errctnt', [
                        style({
                            transform: 'translateY(0%)'
                        }),
                        animate('300ms ease-in', style({
                            transform: 'translateY(100%)'
                        }))
                    ]),
                    query('@*', animateChild(), { optional: true })
                ])
            ])
        ])
    ] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NeSoftErrorComponent, decorators: [{
            type: Component,
            args: [{ selector: 'nesoft-input-error', animations: [
                        trigger('showHideBg', [
                            transition(':enter', [
                                group([
                                    query(':self', [
                                        style({
                                            height: '0px'
                                        }),
                                        animate('300ms ease-in', style({
                                            height: '*'
                                        }))
                                    ]),
                                    query('.nesoft-input-error-container', [
                                        style({
                                            transform: 'translateY(100%)'
                                        }),
                                        animate('300ms ease-in', style({
                                            transform: 'translateY(0%)'
                                        }))
                                    ]),
                                    query('@*', animateChild(), { optional: true })
                                ])
                            ]),
                            transition(':leave', [
                                group([
                                    query(':self', [
                                        style({
                                            height: '*'
                                        }),
                                        animate('300ms ease-out', style({
                                            height: '0px'
                                        }))
                                    ]),
                                    query('.errctnt', [
                                        style({
                                            transform: 'translateY(0%)'
                                        }),
                                        animate('300ms ease-in', style({
                                            transform: 'translateY(100%)'
                                        }))
                                    ]),
                                    query('@*', animateChild(), { optional: true })
                                ])
                            ])
                        ])
                    ], template: "<p class=\"nesoft-input-error-container\">\n  <ng-content></ng-content>\n</p>\n" }]
        }], ctorParameters: function () { return []; }, propDecorators: { showHideBg: [{
                type: HostBinding,
                args: ['@showHideBg']
            }] } });

class NeSoftInputvalidationDirective {
    constructor(formControl) {
        this.formControl = formControl;
        this.update = false;
    }
    onFocus() {
        this.updateValidation();
    }
    onChange() {
        this.updateValidation();
    }
    onBlur() {
        this.updateValidation();
    }
    updateValidation() {
        this.formControl?.control?.markAsTouched();
        this.formControl?.control?.markAsDirty();
        this.formControl?.control?.updateValueAndValidity();
    }
    ngOnChanges(changes) {
        if (this.update) {
            this.updateValidation();
        }
    }
}
NeSoftInputvalidationDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NeSoftInputvalidationDirective, deps: [{ token: i3.NgControl }], target: i0.ɵɵFactoryTarget.Directive });
NeSoftInputvalidationDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.0.0", type: NeSoftInputvalidationDirective, selector: "[nesoftInputvalidation]", inputs: { update: "update" }, host: { listeners: { "focus": "onFocus()", "change": "onChange()", "blur": "onBlur()" } }, usesOnChanges: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NeSoftInputvalidationDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[nesoftInputvalidation]'
                }]
        }], ctorParameters: function () { return [{ type: i3.NgControl }]; }, propDecorators: { update: [{
                type: Input
            }], onFocus: [{
                type: HostListener,
                args: ['focus']
            }], onChange: [{
                type: HostListener,
                args: ['change']
            }], onBlur: [{
                type: HostListener,
                args: ['blur']
            }] } });

class NeSoftInputIfValidationDirective {
    constructor(ifHasValue, isParent = false) {
        this.ifHasValue = ifHasValue;
        this.isParent = isParent;
    }
    validate(c) {
        const hasValue = c.root.get(this.ifHasValue);
        if (!this.isParent) {
            // if other field has a value but the current field not
            if (hasValue && c && hasValue.value && !c.value) {
                return {
                    requiredIf: true
                };
            }
        }
        else {
            // If parent has a value and the slave not
            if (c && c.value && hasValue && (hasValue.touched || hasValue.dirty)) {
                hasValue.markAsDirty();
                hasValue.markAsTouched();
                hasValue.updateValueAndValidity();
            }
            else if (c && !c.value && hasValue && (hasValue.touched || hasValue.dirty)) {
                // If slave has a value put not paren
                hasValue.markAsDirty();
                hasValue.markAsTouched();
                hasValue.updateValueAndValidity();
            }
        }
        return null;
    }
}
NeSoftInputIfValidationDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NeSoftInputIfValidationDirective, deps: [{ token: 'requiredif', attribute: true }, { token: 'isparen', attribute: true }], target: i0.ɵɵFactoryTarget.Directive });
NeSoftInputIfValidationDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.0.0", type: NeSoftInputIfValidationDirective, selector: "[nesoftInputIfValidation]", providers: [{
            provide: NG_VALIDATORS,
            useExisting: forwardRef(() => NeSoftInputIfValidationDirective),
            multi: true
        }], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NeSoftInputIfValidationDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[nesoftInputIfValidation]',
                    providers: [{
                            provide: NG_VALIDATORS,
                            useExisting: forwardRef(() => NeSoftInputIfValidationDirective),
                            multi: true
                        }]
                }]
        }], ctorParameters: function () { return [{ type: undefined, decorators: [{
                    type: Attribute,
                    args: ['requiredif']
                }] }, { type: undefined, decorators: [{
                    type: Attribute,
                    args: ['isparen']
                }] }]; } });

class NeSoftInputOnlyNumberValidationDirective {
    constructor(elem) {
        this.elem = elem;
    }
    onInputChange(event) {
        const initalValue = this.elem.nativeElement.value;
        this.elem.nativeElement.value = initalValue.replace(/[^0-9]*/g, '');
        if (initalValue !== this.elem.nativeElement.value) {
            event.stopPropagation();
        }
    }
}
NeSoftInputOnlyNumberValidationDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NeSoftInputOnlyNumberValidationDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
NeSoftInputOnlyNumberValidationDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.0.0", type: NeSoftInputOnlyNumberValidationDirective, selector: "[nesoftInputOnlyNumberValidation]", host: { listeners: { "input": "onInputChange($event)" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NeSoftInputOnlyNumberValidationDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[nesoftInputOnlyNumberValidation]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { onInputChange: [{
                type: HostListener,
                args: ['input', ['$event']]
            }] } });

class NeSoftInputNotNullIfValidationDirective {
    constructor(requiredifEmpty, isParent = false) {
        this.requiredifEmpty = requiredifEmpty;
        this.isParent = isParent;
    }
    validate(c) {
        const hasValue = c.root.get(this.requiredifEmpty);
        if (!this.isParent) {
            // if other field has a value but the current field not
            if (hasValue && c && !hasValue.value && !c.value) {
                return {
                    requiredIfNotNull: true
                };
            }
        }
        else {
            // If parent has a value and the slave not
            if (c && !c.value && !hasValue && (hasValue.touched || hasValue.dirty)) {
                hasValue.markAsDirty();
                hasValue.markAsTouched();
                hasValue.updateValueAndValidity();
            }
            else if (c && c.value && !hasValue && (hasValue.touched || hasValue.dirty)) {
                // If slave has a value put not parent
                hasValue.markAsDirty();
                hasValue.markAsTouched();
                hasValue.updateValueAndValidity();
            }
        }
        return null;
    }
}
NeSoftInputNotNullIfValidationDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NeSoftInputNotNullIfValidationDirective, deps: [{ token: 'requiredifEmpty', attribute: true }, { token: 'isparent', attribute: true }], target: i0.ɵɵFactoryTarget.Directive });
NeSoftInputNotNullIfValidationDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.0.0", type: NeSoftInputNotNullIfValidationDirective, selector: "[nesoftInputNotNullIfValidation]", providers: [{
            provide: NG_VALIDATORS,
            useExisting: forwardRef(() => NeSoftInputNotNullIfValidationDirective),
            multi: true
        }], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NeSoftInputNotNullIfValidationDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[nesoftInputNotNullIfValidation]',
                    providers: [{
                            provide: NG_VALIDATORS,
                            useExisting: forwardRef(() => NeSoftInputNotNullIfValidationDirective),
                            multi: true
                        }]
                }]
        }], ctorParameters: function () { return [{ type: undefined, decorators: [{
                    type: Attribute,
                    args: ['requiredifEmpty']
                }] }, { type: undefined, decorators: [{
                    type: Attribute,
                    args: ['isparent']
                }] }]; } });

class NeSoftInputMatchValidationDirective {
    constructor(validateEqual) {
        this.validateEqual = validateEqual;
    }
    validate(c) {
        const v = c.value;
        const e = c.root.get(this.validateEqual);
        if (e && e.value && c.value && e.value !== c.value && e.valid) {
            e.setErrors({ match: true });
        }
        if (e && e.value && c.value && e.value === c.value && c.valid && e.invalid) {
            e.updateValueAndValidity();
        }
        // value not equal
        if (e && v !== e.value) {
            return {
                match: true
            };
        }
        return null;
    }
}
NeSoftInputMatchValidationDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NeSoftInputMatchValidationDirective, deps: [{ token: 'match', attribute: true }], target: i0.ɵɵFactoryTarget.Directive });
NeSoftInputMatchValidationDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.0.0", type: NeSoftInputMatchValidationDirective, selector: "[nesoftInputMatchValidation]", providers: [{
            provide: NG_VALIDATORS,
            useExisting: forwardRef(() => NeSoftInputMatchValidationDirective),
            multi: true
        }], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NeSoftInputMatchValidationDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[nesoftInputMatchValidation]',
                    providers: [{
                            provide: NG_VALIDATORS,
                            useExisting: forwardRef(() => NeSoftInputMatchValidationDirective),
                            multi: true
                        }]
                }]
        }], ctorParameters: function () { return [{ type: undefined, decorators: [{
                    type: Attribute,
                    args: ['match']
                }] }]; } });

class NeSoftFormValidationDirective {
    constructor(formGroup) {
        this.formGroup = formGroup;
    }
    get isValid() {
        return this.submitForm();
    }
    onKeyDown(e) {
        this.submitForm().then((result) => {
            return result;
        });
    }
    async disableForm() {
        return new Promise((resolve, reject) => {
            if (this.formGroup) {
                let countItm = 0;
                const totalControls = Object.keys(this.formGroup.controls).length;
                Object.keys(this.formGroup.controls).forEach((name) => {
                    this.formGroup.controls[name].disable();
                    countItm += 1;
                });
                if (countItm === totalControls) {
                    resolve(null);
                }
            }
            else {
                resolve(null);
            }
        });
    }
    async enableForm() {
        return new Promise((resolve, reject) => {
            if (this.formGroup) {
                let countItm = 0;
                const totalControls = Object.keys(this.formGroup.controls).length;
                Object.keys(this.formGroup.controls).forEach((name) => {
                    this.formGroup.controls[name].enable();
                    countItm += 1;
                });
                if (countItm === totalControls) {
                    resolve(null);
                }
            }
            else {
                resolve(null);
            }
        });
    }
    async submitForm() {
        const syncValidationErrors = Object.keys(this.formGroup.controls).map(c => {
            const control = this.formGroup.controls[c];
            return !control.validator ? null : control.validator(control);
        }).filter(errors => !!errors);
        return combineLatest(Object.keys(this.formGroup.controls).map(c => {
            const control = this.formGroup.controls[c];
            return !control.asyncValidator ? of(null) : control.asyncValidator(control);
        })).pipe(map(asyncValidationErrors => {
            const hasErrors = [...syncValidationErrors, ...asyncValidationErrors.filter(errors => !!errors)].length;
            Object.keys(this.formGroup.controls).forEach(key => {
                this.formGroup.controls[key].markAsDirty();
                this.formGroup.controls[key].markAsTouched();
                this.formGroup.controls[key].updateValueAndValidity();
            });
            return !hasErrors;
        })).toPromise();
    }
    async clearForm() {
        return new Promise((resolve, reject) => {
            if (this.formGroup) {
                let countItm = 0;
                const totalControls = Object.keys(this.formGroup.controls).length;
                Object.keys(this.formGroup.controls).forEach((name) => {
                    this.formGroup.controls[name].reset();
                    this.formGroup.controls[name].markAsPristine();
                    this.formGroup.controls[name].markAsUntouched();
                    this.formGroup.controls[name].updateValueAndValidity();
                    countItm += 1;
                });
                if (countItm === totalControls) {
                    resolve(null);
                }
            }
            else {
                resolve(null);
            }
        });
    }
    async resetForm() {
        return new Promise((resolve, reject) => {
            if (this.formGroup) {
                let countItm = 0;
                const totalControls = Object.keys(this.formGroup.controls).length;
                Object.keys(this.formGroup.controls).forEach((name) => {
                    this.formGroup.controls[name].markAsPristine();
                    this.formGroup.controls[name].markAsUntouched();
                    this.formGroup.controls[name].updateValueAndValidity();
                    countItm += 1;
                });
                if (countItm === totalControls) {
                    resolve(null);
                }
            }
            else {
                resolve(null);
            }
        });
    }
}
NeSoftFormValidationDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NeSoftFormValidationDirective, deps: [{ token: i3.NgForm }], target: i0.ɵɵFactoryTarget.Directive });
NeSoftFormValidationDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.0.0", type: NeSoftFormValidationDirective, selector: "[nesoftFormValidation]", host: { listeners: { "keydown.enter": "onKeyDown($event)" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NeSoftFormValidationDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[nesoftFormValidation]'
                }]
        }], ctorParameters: function () { return [{ type: i3.NgForm }]; }, propDecorators: { onKeyDown: [{
                type: HostListener,
                args: ['keydown.enter', ['$event']]
            }] } });

class NeSoftInputModule {
}
NeSoftInputModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NeSoftInputModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NeSoftInputModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.0.0", ngImport: i0, type: NeSoftInputModule, declarations: [NeSoftInputComponent,
        NeSoftErrorComponent,
        NeSoftRadioComponent,
        NeSoftRadioItemComponent,
        NeSoftCheckboxComponent,
        NeSoftInputReferenceComponent,
        NeSoftInputDirective,
        NeSoftPrefixDirective,
        NeSoftSuffixDirective,
        // Validation
        NeSoftInputvalidationDirective,
        NeSoftInputIfValidationDirective,
        NeSoftInputOnlyNumberValidationDirective,
        NeSoftInputNotNullIfValidationDirective,
        NeSoftInputMatchValidationDirective,
        NeSoftFormValidationDirective], imports: [CommonModule,
        HttpClientModule,
        ReactiveFormsModule,
        FormsModule], exports: [NeSoftInputComponent,
        NeSoftErrorComponent,
        NeSoftRadioComponent,
        NeSoftRadioItemComponent,
        NeSoftCheckboxComponent,
        NeSoftInputReferenceComponent,
        NeSoftInputDirective,
        NeSoftPrefixDirective,
        NeSoftSuffixDirective,
        // Validation
        NeSoftInputvalidationDirective,
        NeSoftInputIfValidationDirective,
        NeSoftInputOnlyNumberValidationDirective,
        NeSoftInputNotNullIfValidationDirective,
        NeSoftInputMatchValidationDirective,
        NeSoftFormValidationDirective] });
NeSoftInputModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NeSoftInputModule, imports: [CommonModule,
        HttpClientModule,
        ReactiveFormsModule,
        FormsModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.0.0", ngImport: i0, type: NeSoftInputModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        NeSoftInputComponent,
                        NeSoftErrorComponent,
                        NeSoftRadioComponent,
                        NeSoftRadioItemComponent,
                        NeSoftCheckboxComponent,
                        NeSoftInputReferenceComponent,
                        NeSoftInputDirective,
                        NeSoftPrefixDirective,
                        NeSoftSuffixDirective,
                        // Validation
                        NeSoftInputvalidationDirective,
                        NeSoftInputIfValidationDirective,
                        NeSoftInputOnlyNumberValidationDirective,
                        NeSoftInputNotNullIfValidationDirective,
                        NeSoftInputMatchValidationDirective,
                        NeSoftFormValidationDirective,
                        //NeSoftUserExistValidationDirective,
                        //UserNotExistValidationDirective
                    ],
                    imports: [
                        CommonModule,
                        HttpClientModule,
                        ReactiveFormsModule,
                        FormsModule
                    ],
                    exports: [
                        NeSoftInputComponent,
                        NeSoftErrorComponent,
                        NeSoftRadioComponent,
                        NeSoftRadioItemComponent,
                        NeSoftCheckboxComponent,
                        NeSoftInputReferenceComponent,
                        NeSoftInputDirective,
                        NeSoftPrefixDirective,
                        NeSoftSuffixDirective,
                        // Validation
                        NeSoftInputvalidationDirective,
                        NeSoftInputIfValidationDirective,
                        NeSoftInputOnlyNumberValidationDirective,
                        NeSoftInputNotNullIfValidationDirective,
                        NeSoftInputMatchValidationDirective,
                        NeSoftFormValidationDirective,
                        //NeSoftUserExistValidationDirective,
                    ]
                }]
        }] });

/*
 * Public API Surface of inputs
 */
// export * from './lib/validation/user-exist-validation.directive';
// export * from './lib/validation/user-not-exist-validation.directive';

/**
 * Generated bundle index. Do not edit.
 */

export { NeSoftCheckboxComponent, NeSoftErrorComponent, NeSoftFormValidationDirective, NeSoftInputComponent, NeSoftInputDirective, NeSoftInputIfValidationDirective, NeSoftInputMatchValidationDirective, NeSoftInputModule, NeSoftInputNotNullIfValidationDirective, NeSoftInputOnlyNumberValidationDirective, NeSoftInputReferenceComponent, NeSoftInputvalidationDirective, NeSoftPrefixDirective, NeSoftRadioComponent, NeSoftRadioItemComponent, NeSoftSuffixDirective, RadioModel, ReferenceModel };
//# sourceMappingURL=nesoft-input.mjs.map
