import { ElementRef, EventEmitter, OnInit } from '@angular/core';
import { HttpClient } from "@angular/common/http";
import { AbstractControl, ControlValueAccessor, ValidationErrors, Validator } from "@angular/forms";
import * as i0 from "@angular/core";
export declare class RadioModel {
    Id: string;
    Name: string;
    Value: string;
    constructor(Id?: string, Name?: string, Value?: string);
}
export declare class NeSoftRadioComponent implements OnInit, ControlValueAccessor, Validator {
    private elementRef;
    private httpClient;
    targetUrl: string;
    required: boolean;
    ngModel: string;
    ngModelChange: EventEmitter<string>;
    radioItems: RadioModel[];
    onChange: any;
    onTouch: any;
    get isSuccess(): boolean;
    get isError(): boolean;
    constructor(elementRef: ElementRef, httpClient: HttpClient);
    ngOnInit(): Promise<any>;
    getRadioItems(): Promise<any>;
    updateValidation(): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    writeValue(obj: any): void;
    validate(control: AbstractControl): ValidationErrors | null;
    static ɵfac: i0.ɵɵFactoryDeclaration<NeSoftRadioComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NeSoftRadioComponent, "nesoft-radio", never, { "targetUrl": "targetUrl"; "required": "required"; "ngModel": "ngModel"; }, { "ngModelChange": "ngModelChange"; }, never, never, false>;
}
