import { AfterViewInit, ChangeDetectorRef, EventEmitter, OnInit } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { AbstractControl, ControlValueAccessor, NgControl, ValidationErrors, Validator } from '@angular/forms';
import * as i0 from "@angular/core";
export declare class ReferenceModel {
    Id: string;
    Name: string;
    Value: string;
    constructor(Id?: string, Name?: string, Value?: string);
}
export declare class NeSoftInputReferenceComponent implements OnInit, AfterViewInit, ControlValueAccessor, Validator {
    httpClient: HttpClient;
    private cdr;
    required: boolean;
    disabled: boolean;
    targetUrl: string;
    loadRefObject: boolean;
    refObject: EventEmitter<any>;
    searchLst: any[];
    mselObjId: string;
    msearchValue: string;
    objDescription: string;
    wasInside: boolean;
    onChange: any;
    onTouch: any;
    controlLoaded: boolean;
    set searchValue(value: string);
    get searchValue(): string;
    set ngModel(value: any);
    get ngModel(): any;
    ngModelChange: EventEmitter<any>;
    searchval?: NgControl;
    clickInside(): void;
    clickout(): void;
    constructor(httpClient: HttpClient, cdr: ChangeDetectorRef);
    ngOnInit(): Promise<any>;
    openDetailComp(): void;
    openEditComp(): void;
    openCreateComp(): void;
    clearValue(): void;
    getSearchResults(): Promise<any>;
    loadSearchList(): void;
    initialize(): Promise<any>;
    getRefObject(): Promise<any>;
    getObjectDesc(): Promise<any>;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    writeValue(obj: any): void;
    validate(control: AbstractControl): ValidationErrors | null;
    ngAfterViewInit(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NeSoftInputReferenceComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NeSoftInputReferenceComponent, "nesoft-reference", never, { "required": "required"; "disabled": "disabled"; "targetUrl": "targetUrl"; "loadRefObject": "loadRefObject"; "ngModel": "ngModel"; }, { "refObject": "refObject"; "ngModelChange": "ngModelChange"; }, never, never, false>;
}
